/*
 * arch/arm/mach-cxd4105/uart.S
 *
 * UART initialize for cxd4105
 *
 * Copyright 2007 Sony Corporation
 *
 */

#include <linux/linkage.h>
#include <asm/assembler.h>
#include <asm/hardware.h>
#include <asm/arch/regs-clk.h>
#include <asm/arch/regs-gpio.h>
#include <asm/arch/regs-uart.h>
#include <linux/amba/serial.h>

	.text				
ENTRY(uart0_init)
	@ Preserve r0 and r1
	@ select CLK
	ldr	r2, =CXD4105_CLKBLK_BASE
	mov	r3, #0x01
	str	r3, [r2, #CLKBLK_SELCKUART0]	@ select 14.769MHz
	str	r3, [r2, #CLKBLK_PSCKUART0]	@ enable UART0 CLK

	@ select GPIO
	ldr	r2, =CXD4105_GPIO(CXD4105_UART_GPIO) @ GPIOE1 base
	mov	r3, #0x01
	str	r3, [r2, #GPIOE_PORTSEL(0)]	@ GPIOE1_1 as UART0 TXD

	@ 115200bps,8N1
	ldr	r2, =CXD4105_UART0_BASE
	mov	r3, #0x01
	str	r3, [r2, #UART011_FBRD]
	mov	r3, #0x08
	str	r3, [r2, #UART011_IBRD]
	mov	r3, #0x70
	str	r3, [r2, #UART011_LCRH]
	@ TX enable
	mov	r3, #0x0100
	orr	r3, r3, #0x0001
	str	r3, [r2, #UART011_CR]
	
	mov	pc, lr
