/*--------------------------------------------------------------------------*
 * drivers/usb/mcd/usb_mcd_board_cxd4115.h
 * 
 * USB controller driver
 * 
 * Copyright 2009 Sony Corporation
 *
 * This file is part of the Inventra Controller Driver for Linux.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *---------------------------------------------------------------------------*/

/************************** macro, variable definitions ***********************/

#if !defined(CONFIG_ARCH_CXD4120)
#define _BOARD_CXD4115_
#endif /* !defined(CONFIG_ARCH_CXD4120) */

/*
 * device
 */
/* ɥ쥹 */
#define ADR_START	0x78020000
#define ADR_END  	0x78021000

/*
 * ޡ
 */
/* Timer ch */
#ifdef _BOARD_CXD4115_
#define TIMER_FOR_USB		0
#else
#define TIMER_FOR_USB		3
#endif	/* _BOARD_CXD4115_ */

/*
 * PPARAM
 */
#define BOARD_PPARAM0		{ \
	0x44, 0x44, 0x44, 0x22, 0x22, 0x08, 0x17, 0x08, 0x00, 0x1f, 0x00, 0x00 }
#define BOARD_PPARAM1		{ \
	0x00, 0x00, 0x33, 0x22, 0x22, 0x0a, 0x12, 0x04, 0x00, 0x1f, 0x00, 0x00 }
#define BOARD_PPARAM2		{ \
	0x44, 0x44, 0x44, 0x22, 0x22, 0x08, 0x00, 0x08, 0x00, 0x1f, 0x00, 0x00 }
#define BOARD_PPARAM3		{ \
	0x00, 0x00, 0x44, 0x22, 0x22, 0x08, 0x00, 0x10, 0x00, 0x18, 0x00, 0x00 }

#define BOARD_PPARAM_NUM	12

/*
 * åbit
 */
/* CLKRST */
#ifdef _BOARD_CXD4115_
#define CLKRST_XPS4		17
#define CLKRST_XPS4_USBPHY	0x00000010 /* ReadModifyWrite */
#else
#define ADR_CLKRST_XPS_DATA	0x7A4201A0
#define ADR_CLKRST_XPS_SET	0x7A4201A4
#define ADR_CLKRST_XPS_CLR	0x7A4201A8
#define CLKRST_XPS_USBPHY_ON	0x00000001
#define VA_CLKRST_XPS_DATA	IO_ADDRESSP(ADR_CLKRST_XPS_DATA)
#define VA_CLKRST_XPS_SET	IO_ADDRESSP(ADR_CLKRST_XPS_SET)
#define VA_CLKRST_XPS_CLR	IO_ADDRESSP(ADR_CLKRST_XPS_CLR)
#endif	/* _BOARD_CXD4115_ */

/* HSTCTRL */
#ifdef _BOARD_CXD4115_
#define CLKBLK_USB_HCLK		0x064
#define CLKBLK_USB_RST		0x324
#else
#define ADR_PSHCLKUSB		0x7A058064
#define PSHCLKUSB_ON		0x00000001
#define PSHCLKUSB_OFF		0x00000000
#define ADR_PSCKUSBPHY		0x7A05806C
#define PSCKUSBPHY_ON		0x00000001
#define PSCKUSBPHY_OFF		0x00000000
#define ADR_RSTUSB_X		0x7A058324
#define RSTUSB_X_ASSERT		0x00000000
#define RSTUSB_X_NEGATE		0x00000001
#define VA_PSHCLKUSB		IO_ADDRESSP(ADR_PSHCLKUSB)
#define VA_PSCKUSBPHY		IO_ADDRESSP(ADR_PSCKUSBPHY)
#define VA_RSTUSB_X		IO_ADDRESSP(ADR_RSTUSB_X)
#endif	/* _BOARD_CXD4115_ */

/*
 * MISCTOP
 */
#define MISCCTRL_TID		2

#define TID_TMSK		0x0000ff00
#define TID_EMSK		0x000000ff
#define TID1			0x00008000
#define TID2			0x00008001
#define TID3			0x00000100

/*
 * MISCTOP(USB)
 */
#ifdef _BOARD_CXD4115_
#define CXD41xx_MISCUSB(x)	(CXD4115_APB1_BASE + 0x50000 + 0x10*(x))
#else
#define CXD41xx_MISCUSB(x)	(CXD4115_APB1_BASE + 0x30400 + 0x10*(x))
#endif	/* _BOARD_CXD4115_ */
#define VA_MISCUSB(x)		IO_ADDRESSP(CXD41xx_MISCUSB(x))

#define MISCUSB_DATA		0x00
#define MISCUSB_SET		0x04
#define MISCUSB_CLR		0x08
#define MISCUSB_SEL		0x10
#define MISCUSB_SELSET		0x14
#define MISCUSB_SELCLR		0x18
#ifdef _BOARD_CXD4115_
#define MISCUSB_RE		0x20
#define MISCUSB_RESET		0x24
#define MISCUSB_RECLR		0x28
#define MISCUSB_RD		0x2c
#else
#define MISCUSB_RD		0x1c
#endif	/* _BOARD_CXD4115_ */

#define VA_MISCUSB_DATA(x)	(VA_MISCUSB(x) + MISCUSB_DATA)
#define VA_MISCUSB_SET(x)	(VA_MISCUSB(x) + MISCUSB_SET)
#define VA_MISCUSB_CLR(x)	(VA_MISCUSB(x) + MISCUSB_CLR)
#define VA_MISCUSB_SEL(x)	(VA_MISCUSB(x) + MISCUSB_SEL)
#define VA_MISCUSB_SELSET(x)	(VA_MISCUSB(x) + MISCUSB_SELSET)
#define VA_MISCUSB_SELCLR(x)	(VA_MISCUSB(x) + MISCUSB_SELCLR)
#ifdef _BOARD_CXD4115_
#define VA_MISCUSB_RE(x)	(VA_MISCUSB(x) + MISCUSB_RE)
#define VA_MISCUSB_RESET(x)	(VA_MISCUSB(x) + MISCUSB_RESET)
#define VA_MISCUSB_RECLR(x)	(VA_MISCUSB(x) + MISCUSB_RECLR)
#endif	/* _BOARD_CXD4115_ */
#define VA_MISCUSB_RD(x)	(VA_MISCUSB(x) + MISCUSB_RD)

#define MISCUSB_USBPHY0		0
#define MISCUSB_USBPHY1		1
#define MISCUSB_USBPHY2		2
#define MISCUSB_USBPHY3		3
#define MISCUSB_USBSIGCNT0	4
#ifdef _BOARD_CXD4115_
#define MISCUSB_USBSIGCNT1	7
#define MISCUSB_USBSIGCNT2	10
#else
#define MISCUSB_USBSIGCNT1	6
#define MISCUSB_USBSIGCNT2	8
#endif	/* _BOARD_CXD4115_ */

#define MISCUSB_USBPHY0_HRSTBI		0
#define MISCUSB_USBPHY3_VCMPENI		12
#define MISCUSB_USBSIGCNT0_SUSPENDBI	21
#define MISCUSB_USBSIGCNT0_IDPULLUPI	25
#define MISCUSB_USBSIGCNT2_IDDIGO	0
#define MISCUSB_USBSIGCNT2_VBUSVLDO	1
#define MISCUSB_USBSIGCNT2_ASESSVLDO	2
#define MISCUSB_USBSIGCNT2_BSESSENDO	3
#define MISCUSB_USBSIGCNT2_VBUSMSK	0x0000000e

#define BITP(BIT)	(1 << (BIT))

/*
 * timeout for PHY lock
 */
#define TIMEOUT_FOR_PHY_LOCK	100 /* PHY PLL lock time 83[us] */

/***************************** internal functions *****************************/

/*  misc_set_in ... bitǡϤ */
static inline void misc_set_in_all(u32 nr)
{
#ifdef _BOARD_CXD4115_
	writel(0xffffffff, VA_MISCUSB_RESET(nr));
#endif	/* _BOARD_CXD4115_ */
}

/*  misc_set_in ... 1bitǡϤ */
static inline void misc_set_in(u32 nr, u8 bit)
{
	u32 reg = BITP(bit);
	writel(reg, VA_MISCUSB_SELCLR(nr));
#ifdef _BOARD_CXD4115_
	writel(reg, VA_MISCUSB_RESET(nr));
#endif	/* _BOARD_CXD4115_ */
}

/*  misc_set_out ... 1bitǡ */
static inline void misc_set_out(u32 nr, u8 bit, bool data)
{
	u32 reg = BITP(bit);
	writel(reg, VA_MISCUSB_SELSET(nr));
	writel(reg, data ? VA_MISCUSB_SET(nr) : VA_MISCUSB_CLR(nr));
#ifdef _BOARD_CXD4115_
	writel(reg, VA_MISCUSB_RESET(nr));
#endif	/* _BOARD_CXD4115_ */
}

/*  misc_set_out ... 1bitǡʤ */
static inline void misc_set_out_nodata(u32 nr, u8 bit)
{
	u32 reg = BITP(bit);
	writel(reg, VA_MISCUSB_SELSET(nr));
#ifdef _BOARD_CXD4115_
	writel(reg, VA_MISCUSB_RESET(nr));
#endif	/* _BOARD_CXD4115_ */
}

/*  misc_phy_set_out ... 1bitǡ */
static inline void misc_phy_set_out(u32 nr, u8 bit, bool data)
{
	u32 reg = BITP(bit);
	writel(reg, data ? VA_MISCUSB_SET(nr) : VA_MISCUSB_CLR(nr));
}

/*  misc_set_func ... 1bitǽԥ */
static inline void misc_set_func(u32 nr, u8 bit)
{
	u32 reg = BITP(bit);
	writel(reg, VA_MISCUSB_SELCLR(nr));
#ifdef _BOARD_CXD4115_
	writel(reg, VA_MISCUSB_RESET(nr));
#endif	/* _BOARD_CXD4115_ */
}

/*  misc_check_func ... 1bitǽԥǧ */
static inline u8 misc_check_func(u32 nr, u8 bit)
{
	u32 sel = readl(VA_MISCUSB_SEL(nr));
	return 1 & sel >> bit;
}

/*  misc_read32 ... 32bitǡ */
static inline u32 misc_read32(u32 nr)
{
	return readl(VA_MISCUSB_RD(nr));
}

/*  misc_phy_read32 ... 32bitǡ */
static inline u32 misc_phy_read32(u32 nr)
{
	return readl(VA_MISCUSB_DATA(nr));
}

/*  misc_read ... 1bitǡ */
static inline bool misc_read(u32 nr, u8 bit)
{
	u32 data = misc_read32(nr);
	return 1 & data >> bit;
}

/*  misc_write32 ... 32bitǡ */
static inline void misc_write32(u32 nr, u32 data)
{
	writel(data, VA_MISCUSB_SET(nr));
	writel(~data, VA_MISCUSB_CLR(nr));
}

/*  misc_phy_write32 ... 32bitǡ */
static inline void misc_phy_write32(u32 nr, u32 data)
{
	writel(data, VA_MISCUSB_SET(nr));
	writel(~data, VA_MISCUSB_CLR(nr));
}

/*  misc_pparam_write32 ... 32bitǡ */
static inline void misc_pparam_write32(u32 nr, u8 d3, u8 d2, u8 d1, u8 d0)
{
	misc_phy_write32(nr, d3 << 24 | d2 << 16 | d1 << 8 | d0);
}

/* misc_get_stat ... 1bitּ */
static inline u8 misc_get_stat(u32 nr, u8 bit)
{
	if (nr <= MISCUSB_USBPHY3) {
		return misc_read(nr, bit) ? USB_OTG_ON : USB_OTG_OFF;
	}
	
	return (misc_check_func(nr, bit) ? USB_OTG_THRU :
		misc_read(nr, bit) ? USB_OTG_ON : USB_OTG_OFF);
}

/* PHY CLK ON */
#ifdef _BOARD_CXD4115_
static inline void phy_clock_on(void)
{
	u32 clkrst_xps4 = readl(VA_CLKRST_SET(CLKRST_XPS4));
	DBG(3, "READ clkrst_xps4=%x\n", clkrst_xps4);
	if (!(clkrst_xps4 & CLKRST_XPS4_USBPHY)) {
		writel(clkrst_xps4 | CLKRST_XPS4_USBPHY,
		       VA_CLKRST_SET(CLKRST_XPS4));
		DBG(3, "SET clkrst_xps4=%x\n",
		    readl(VA_CLKRST_SET(CLKRST_XPS4)));
	}
	/* SuspendǽOFF */
	misc_set_out(MISCUSB_USBSIGCNT0, MISCUSB_USBSIGCNT0_SUSPENDBI, ON);
	/* PHY PLL lock time 83[us] */
	udelay(100);
}
#else
static inline void phy_clock_on(void)
{
	u32 clkrst_xps4 = readl(VA_CLKRST_XPS_DATA);
	u32 usbphy = readl(VA_PSCKUSBPHY);
	DBG(3, "READ clkrst_xps4=%x\n", clkrst_xps4);
	if (!(clkrst_xps4 & CLKRST_XPS_USBPHY_ON)) {
		writel(clkrst_xps4 | CLKRST_XPS_USBPHY_ON,
		       VA_CLKRST_XPS_SET);
		DBG(3, "SET clkrst_xps4=%x\n",
		    readl(VA_CLKRST_XPS_DATA));
	}
	if (!(usbphy & PSCKUSBPHY_ON)) {
		writel(PSCKUSBPHY_ON, VA_PSCKUSBPHY);
		DBG(3, "SET usbphy=%x\n",
		    readl(VA_PSCKUSBPHY));
	}
	/* SuspendǽOFF */
	misc_set_out(MISCUSB_USBSIGCNT0, MISCUSB_USBSIGCNT0_SUSPENDBI, ON);
	/* PHY PLL lock time 83[us] */
	udelay(100);
}
#endif	/* _BOARD_CXD4115_ */

/* phy_reset phyꥻå */
static inline void phy_reset(void)
{
	misc_phy_set_out(MISCUSB_USBPHY0, MISCUSB_USBPHY0_HRSTBI, OFF);
	udelay(3);
	misc_phy_set_out(MISCUSB_USBPHY0, MISCUSB_USBPHY0_HRSTBI, ON);
}

/* LINK CLK OFF */
#ifdef _BOARD_CXD4115_
static void link_clock_off(void)
{
	u32 usb_hclk = readl(VA_HSTCTRL + CLKBLK_USB_HCLK);
	DBG(3, "READ usb_hclk=%x\n", usb_hclk);
	if (usb_hclk & CLKBLK_CLOCK_ON) {
		writel(CLKBLK_CLOCK_OFF, VA_HSTCTRL + CLKBLK_USB_HCLK);
		writel(CLKBLK_RESET_ASSERT, VA_HSTCTRL + CLKBLK_USB_RST);
		DBG(3, "SET usb_hclk=%x\n",
		    readl(VA_HSTCTRL + CLKBLK_USB_HCLK));
	}
}
#else
static void link_clock_off(void)
{
	u32 usb_hclk = readl(VA_PSHCLKUSB);
	DBG(3, "READ usb_hclk=%x\n", usb_hclk);
	if (usb_hclk & PSHCLKUSB_ON) {
		writel(PSHCLKUSB_OFF, VA_PSHCLKUSB);
		writel(RSTUSB_X_ASSERT, VA_RSTUSB_X);
		DBG(3, "SET usb_hclk=%x\n",
		    readl(VA_PSHCLKUSB));
	}
}
#endif	/* _BOARD_CXD4115_ */

/* LINK CLK ON */
#ifdef _BOARD_CXD4115_
static void link_clock_on(void)
{
	u32 usb_hclk = readl(VA_HSTCTRL + CLKBLK_USB_HCLK);
	DBG(3, "READ usb_hclk=%x\n", usb_hclk);
	if (!(usb_hclk & CLKBLK_CLOCK_ON)) {
		writel(CLKBLK_RESET_NEGATE, VA_HSTCTRL + CLKBLK_USB_RST);
		writel(CLKBLK_CLOCK_ON, VA_HSTCTRL + CLKBLK_USB_HCLK);
		DBG(3, "SET usb_hclk=%x\n",
		    readl(VA_HSTCTRL + CLKBLK_USB_HCLK));
	}
}
#else
static void link_clock_on(void)
{
	u32 usb_hclk = readl(VA_PSHCLKUSB);
	DBG(3, "READ usb_hclk=%x\n", usb_hclk);
	if (!(usb_hclk & PSHCLKUSB_ON)) {
		writel(RSTUSB_X_NEGATE, VA_RSTUSB_X);
		writel(PSHCLKUSB_ON, VA_PSHCLKUSB);
		DBG(3, "SET usb_hclk=%x\n",
		    readl(VA_PSHCLKUSB));
	}
}
#endif	/* _BOARD_CXD4115_ */

/* all clock off */
static inline void clock_off(void)
{
	DBG(2, "<==\n");
	/* SUSPEND# Suspend */
	misc_set_out(MISCUSB_USBSIGCNT0, MISCUSB_USBSIGCNT0_SUSPENDBI, OFF);
	link_clock_off();
	DBG(2, "==>\n");
}

/* all clock on */
static inline void clock_on(void)
{
	DBG(2, "<==\n");
	link_clock_on();
	/* SUSPEND# ǽԥ */
	misc_set_func(MISCUSB_USBSIGCNT0, MISCUSB_USBSIGCNT0_SUSPENDBI);
	DBG(2, "==>\n");
}

/* check clock activity */
#ifdef _BOARD_CXD4115_
static inline u8 check_clock(void)
{
	u32 usb_hclk = readl(VA_HSTCTRL + CLKBLK_USB_HCLK);
	return usb_hclk & CLKBLK_CLOCK_ON ? USB_OTG_ON : USB_OTG_OFF;
}
#else
static inline u8 check_clock(void)
{
	u32 usb_hclk = readl(VA_PSHCLKUSB);
	return usb_hclk & PSHCLKUSB_ON ? USB_OTG_ON : USB_OTG_OFF;
}
#endif	/* _BOARD_CXD4115_ */

/* set_pparam ... set pparam */
static inline int set_pparam(u8 *prm)
{
	misc_pparam_write32(MISCUSB_USBPHY1, prm[3], prm[2], prm[1], prm[0]);
	misc_pparam_write32(MISCUSB_USBPHY2, prm[7], prm[6], prm[5], prm[4]);
	misc_pparam_write32(MISCUSB_USBPHY3, prm[11], prm[10], prm[9], prm[8]);
	DBG(2, "USBPHY1 0x%x\n", misc_phy_read32(MISCUSB_USBPHY1));
	DBG(2, "USBPHY2 0x%x\n", misc_phy_read32(MISCUSB_USBPHY2));
	DBG(2, "USBPHY3 0x%x\n", misc_phy_read32(MISCUSB_USBPHY3));

	return 0;
}

/**************************** check functions *****************************/

static inline bool read_iddig(void)
{
	return misc_read(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_IDDIGO);
}

static inline void control_iddig_b(void)
{
	misc_set_out(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_IDDIGO, ON);
}

static inline void control_iddig_a(void)
{
	misc_set_out(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_IDDIGO, OFF);
}

static inline void control_iddig_thru(void)
{
	misc_set_func(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_IDDIGO);
}

static inline enum usb_otg_vbus_stat read_vbusin(void)
{
	enum usb_otg_vbus_stat vbus_stat;

	/* Vbus GPIOФʤMISCˤVbus */
	u32 usbsigcnt2 = misc_read32(MISCUSB_USBSIGCNT2);

	switch (usbsigcnt2 & MISCUSB_USBSIGCNT2_VBUSMSK) {
	case BITP(MISCUSB_USBSIGCNT2_BSESSENDO):
		vbus_stat = USB_OTG_VBUS_STAT_OFF;
		break;
	case 0:
		vbus_stat = USB_OTG_VBUS_STAT_LOW;
		break;
	case BITP(MISCUSB_USBSIGCNT2_ASESSVLDO):
		vbus_stat = USB_OTG_VBUS_STAT_SESS;
		break;
	case BITP(MISCUSB_USBSIGCNT2_ASESSVLDO) |
		BITP(MISCUSB_USBSIGCNT2_VBUSVLDO):
		vbus_stat = USB_OTG_VBUS_STAT_VALID;
		break;
	default:
		vbus_stat = USB_OTG_VBUS_STAT_UNKNOWN;
		warn("Unkonwn vbus stat=%d", usbsigcnt2);
	}

	return vbus_stat;
}

static inline void control_vbusin_on(void)
{
	misc_set_out(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_BSESSENDO, OFF);
	misc_set_out(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_ASESSVLDO, ON);
	misc_set_out(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_VBUSVLDO, ON);
}

static inline void control_vbusin_off(void)
{
	misc_set_out(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_BSESSENDO, ON);
	misc_set_out(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_ASESSVLDO, OFF);
	misc_set_out(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_VBUSVLDO, OFF);
}

static inline void control_vbusin_thru(void)
{
	misc_set_func(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_BSESSENDO);
	misc_set_func(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_ASESSVLDO);
	misc_set_func(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_VBUSVLDO);
}

static inline void control_vbusin_out(void)
{
	misc_set_out_nodata(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_BSESSENDO);
	misc_set_out_nodata(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_ASESSVLDO);
	misc_set_out_nodata(MISCUSB_USBSIGCNT2, MISCUSB_USBSIGCNT2_VBUSVLDO);
}

static inline u8 check_vbusin(void)
{
	u8 sessend;
	u8 avalid;
	u8 vbusvalid;

	sessend   = misc_get_stat(MISCUSB_USBSIGCNT2,
				  MISCUSB_USBSIGCNT2_BSESSENDO);
	avalid    = misc_get_stat(MISCUSB_USBSIGCNT2,
				  MISCUSB_USBSIGCNT2_ASESSVLDO);
	vbusvalid = misc_get_stat(MISCUSB_USBSIGCNT2,
				  MISCUSB_USBSIGCNT2_VBUSVLDO);

	if (sessend   == USB_OTG_THRU &&
	    avalid    == USB_OTG_THRU &&
	    vbusvalid == USB_OTG_THRU) {
		return USB_OTG_THRU;
	}
	else if (sessend   == USB_OTG_ON &&
		 avalid    == USB_OTG_OFF &&
		 vbusvalid == USB_OTG_OFF) {
		return USB_OTG_OFF;
	}

	return USB_OTG_ON;
}

static inline void control_vcmpen_on(void)
{
	/* VCMPEN# OFF - ͭ */
	misc_phy_set_out(MISCUSB_USBPHY3, MISCUSB_USBPHY3_VCMPENI, OFF);
}

static inline void control_vcmpen_off(void)
{
	/* VCMPEN# ON - ̵ */
	misc_phy_set_out(MISCUSB_USBPHY3, MISCUSB_USBPHY3_VCMPENI, ON);
}

static inline bool read_suspend(void)
{
	return !(misc_read(MISCUSB_USBSIGCNT0, MISCUSB_USBSIGCNT0_SUSPENDBI));
}

static inline void control_suspend_off(void)
{
	/* SuspendǽOFF */
	misc_set_out(MISCUSB_USBSIGCNT0, MISCUSB_USBSIGCNT0_SUSPENDBI, ON);
}

static inline void control_suspend_on(void)
{
	/* SuspendǽON */
	misc_set_out(MISCUSB_USBSIGCNT0, MISCUSB_USBSIGCNT0_SUSPENDBI, OFF);
}

static inline void control_suspend_thru(void)
{
	/* Suspendǽǽԥ */
	misc_set_func(MISCUSB_USBSIGCNT0, MISCUSB_USBSIGCNT0_SUSPENDBI);
}

static inline void control_idpullup_off(void)
{
	misc_set_out(MISCUSB_USBSIGCNT0, MISCUSB_USBSIGCNT0_IDPULLUPI, OFF);
}

static inline void control_idpullup_on(void)
{
	misc_set_out(MISCUSB_USBSIGCNT0, MISCUSB_USBSIGCNT0_IDPULLUPI, ON);
}

static inline bool check_gpio_sys(gpio_portid prt)
{
	return (prt == GPIO_PORT_0);
}

#define PRINT_USBSIGCNT(NR) \
{ \
	printk(" " #NR " 0x%.8x(S%.8x,D%.8x,R%.8x)\n", \
	       misc_read32(NR), \
	       readl(VA_MISCUSB_SEL(NR)), \
	       readl(VA_MISCUSB_DATA(NR)), \
	       readl(VA_MISCUSB_RD(NR))); \
}

#define PRINT_USBPHY(NR) \
{ \
	printk(" " #NR " 0x%.8x\n", \
	       readl(VA_MISCUSB_DATA(NR))); \
}

static inline void control_linestate_set(void)
{
	writel( 0x02000000, VA_MISCUSB_SET(MISCUSB_USBSIGCNT1) );
	writel( 0x02000000, VA_MISCUSB_SELSET(MISCUSB_USBSIGCNT1) );

#if MCD_DEBUG > 0
#ifdef _BOARD_CXD4115_
	writel( 0x02000000, VA_MISCUSB_RE(MISCUSB_USBSIGCNT1) );
	writel( 0x02000000, VA_MISCUSB_RESET(MISCUSB_USBSIGCNT1) );
#endif	/* _BOARD_CXD4115_ */
	printk("Write Address: %x, DATA: %x\n", (unsigned int)(VA_MISCUSB_RD(MISCUSB_USBSIGCNT1)), readl(VA_MISCUSB_RD(MISCUSB_USBSIGCNT1)) );
#endif

	writel( 0x02000000, VA_MISCUSB_SELCLR(MISCUSB_USBSIGCNT1) );

#if MCD_DEBUG > 0
	printk("Write Address: %x, DATA: %x\n", (unsigned int)(VA_MISCUSB_RD(MISCUSB_USBSIGCNT1)), readl(VA_MISCUSB_RD(MISCUSB_USBSIGCNT1)) );
#ifdef _BOARD_CXD4115_
	writel( 0x02000000, VA_MISCUSB_RECLR(MISCUSB_USBSIGCNT1) );
#endif	/* _BOARD_CXD4115_ */
#endif
}

static inline void dump_misc(void)
{
	PRINT_USBPHY(MISCUSB_USBPHY0);
	PRINT_USBPHY(MISCUSB_USBPHY1);
	PRINT_USBPHY(MISCUSB_USBPHY2);
	PRINT_USBPHY(MISCUSB_USBPHY3);
	PRINT_USBSIGCNT(MISCUSB_USBSIGCNT0);
	PRINT_USBSIGCNT(MISCUSB_USBSIGCNT1);
	PRINT_USBSIGCNT(MISCUSB_USBSIGCNT2);
}

#if defined(CONFIG_USB_MCD_HOST)
static int set_gpio_func(gpio_portid, gpio_bitnum, gpio_mode);

static inline void init_vbusout(void)
{
}

static inline void exit_vbusout(void)
{
}

static inline void enable_vbusout(void)
{
#ifdef _BOARD_CXD4115_
	set_gpio_func(GPIO_PORT_1, 28, GPIOMODE_OUTPUT_H);
#else
	set_gpio_func(GPIO_PORT_2, 5, GPIOMODE_OUTPUT_H);
#endif	/* _BOARD_CXD4115_ */
}

static inline void disable_vbusout(void)
{
#ifdef _BOARD_CXD4115_
	set_gpio_func(GPIO_PORT_1, 28, GPIOMODE_OUTPUT_L);
#else
	set_gpio_func(GPIO_PORT_2, 5, GPIOMODE_OUTPUT_L);
#endif	/* _BOARD_CXD4115_ */
}
#endif				/* defined(CONFIG_USB_MCD_HOST) */

static inline void set_monitor(void)
{
	/* GPIO˥ */
	misc_set_in_all(MISCUSB_USBSIGCNT0);
	misc_set_in_all(MISCUSB_USBSIGCNT1);
	misc_set_in_all(MISCUSB_USBSIGCNT2);
}

static inline void suspend_save(struct _cxd41xx_suspend_save *save)
{
	save->clock     = check_clock();
	save->iddig     = misc_get_stat(MISCUSB_USBSIGCNT2,
					MISCUSB_USBSIGCNT2_IDDIGO);
	save->vbusin    = check_vbusin();
	save->vcmpen    = misc_get_stat(MISCUSB_USBPHY3, MISCUSB_USBPHY3_VCMPENI);
	save->suspend   = misc_get_stat(MISCUSB_USBSIGCNT0,
					MISCUSB_USBSIGCNT0_SUSPENDBI);
	save->idpullup  = misc_get_stat(MISCUSB_USBSIGCNT0,
					MISCUSB_USBSIGCNT0_IDPULLUPI);
}

static inline void resume_restore(struct _cxd41xx_suspend_save *save,
				  u8 *_pparam)
{
	if (save->clock == USB_OTG_ON) {
		clock_on();
	}
	else {
		clock_off();
	}

	if (save->iddig == USB_OTG_ON) {
		control_iddig_b();
	}
	else if (save->iddig == USB_OTG_OFF) {
		control_iddig_a();
	} 
	else {
		control_iddig_thru();
	}

	if (save->vbusin == USB_OTG_ON ||
	    save->vbusin == USB_OTG_OFF) {
		control_vbusin_out();
	} 
	else {
		control_vbusin_thru();
	}

	if (save->vcmpen == USB_OTG_ON) {
		control_vcmpen_on();
	}
	else {
		control_vcmpen_off();
	}

	if (save->suspend == USB_OTG_ON) {
		control_suspend_on();
	}
	else if (save->suspend == USB_OTG_OFF) {
		control_suspend_off();
	} 
	else {
		control_suspend_thru();
	}

	if (save->idpullup == USB_OTG_ON) {
		control_idpullup_on();
	}
	else {
		control_idpullup_off();
	}

	set_monitor();
	set_pparam(_pparam);
}

static inline void cxd41xx_init(u8 *data)
{
	u32 tid;
	u8 *_pparam;
	u8 _pparam0[] = BOARD_PPARAM0;
	u8 _pparam1[] = BOARD_PPARAM1;
	u8 _pparam2[] = BOARD_PPARAM2;
	u8 _pparam3[] = BOARD_PPARAM3;

	/* PPARAM */
	tid = readl(VA_MISCCTRL_DATA(MISCCTRL_TID));
	if (tid == TID1) {
		_pparam = _pparam1;
	}
	else if ((tid & TID_TMSK) == (TID2 & TID_TMSK)) {
		_pparam = _pparam2;
	}
	else if ((tid & TID_TMSK) == (TID3 & TID_TMSK)) {
		_pparam = _pparam3;
	}
	else {
		_pparam = _pparam0;
	}
	memcpy(data, _pparam, BOARD_PPARAM_NUM);

	set_monitor();
}

static inline void cxd41xx_exit(void)
{
}
