/*-----------------------------------------------------------------------------
 * drivers/usb/mcd/usb_mcd_cnf.h
 * 
 * USB controller driver
 * 
 * Copyright 2009 Sony Corporation
 *
 * This file is part of the Inventra Controller Driver for Linux.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *---------------------------------------------------------------------------*/

#ifndef _USB_MCD_CNF_H_
#define _USB_MCD_CNF_H_

#define MCD_NUM_IRQS	2
#define MCD_NUM_REGS	2

#define MCD_INTR_REG	0
#define MCD_LINK_REG	1

/* irq for PCI */
#define MCD_PCI_IRQ	0
/* irq for platform */
#define MCD_LINK_IRQ	0
#define MCD_DMAC_IRQ	1

#define MCD_NUM_EPS	7
#if defined(CONFIG_ARCH_INTEGRATOR)
#define MCD_NUM_DMACH	1
#else
#define MCD_NUM_DMACH	4
#endif

#define MCD_END0_FIFOSIZE      64	/* this is non-configurable */

#endif			/* _USB_MCD_CNF_H_ */
