/*
 * include/asm-arm/arch-cxd4105/platform.h
 *
 * CXD4105 address map
 *
 * Copyright 2005,2006 Sony Corporation
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 */
#ifndef __PLATFORM_H__
#define __PLATFORM_H__

#define CXD4105_AHB_BASE	0x70000000
#define CXD4105_AHB_SIZE	(12*SZ_1M)

#define CXD4105_APB_BASE	0x72000000
#define CXD4105_APB_SIZE	(4*SZ_32M)
#define CXD4105_APB0_BASE	(CXD4105_APB_BASE+0)
#define CXD4105_APB1_BASE	(CXD4105_APB_BASE+SZ_32M*1)
#define CXD4105_APB2_BASE	(CXD4105_APB_BASE+SZ_32M*2)
#define CXD4105_APB3_BASE	(CXD4105_APB_BASE+SZ_32M*3)

#if defined(CONFIG_ARCH_MB8AC102)
# define ETB_BASE		(CXD4105_AHB_BASE+SZ_1M*6)
# define ETB_SIZE		(SZ_16K)
# define VA_ETB			IO_ADDRESS(ETB_BASE)
#else
# define CXD4105_HIO_BASE	0xfff00000
# define CXD4105_HIO_SIZE	(SZ_1M)
# define ETB_BASE		(CXD4105_HIO_BASE+0xf2000)
# define ETB_SIZE		(SZ_8K)
# define VA_ETB			HIO_ADDRESS(ETB_BASE)
#endif /* CONFIG_ARCH_MB8AC102 */

#ifndef __ASSEMBLY__
extern int cxd4105_core_init(void);
extern struct sys_timer cxd4105_timer;
extern void cxd4105_map_io(void);
extern void cxd4105_init_irq(void);
#endif /* !__ASSEMBLY__ */

#endif /* __PLATFORM_H__ */
