/*
 * include/asm-arm/arch-cxd4115/hwtimer.h
 *
 * Hardware timer definitions
 *
 * Copyright 2007,2008,2009 Sony Corporation
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 */

#ifndef __ASM_ARCH_HWTIMER_H
#define __ASM_ARCH_HWTIMER_H

#define TIMER_1MSEC 1000 /* 1msec = 1000 count */

extern unsigned long hwtimer_read_clock(void);
extern void hwtimer_init_timer(struct timer_list *, void (*func)(unsigned long), unsigned long);
extern void hwtimer_mod_timer(struct timer_list *, unsigned long);
extern void hwtimer_add_timer(struct timer_list *, unsigned long);
extern void hwtimer_del_timer(struct timer_list *);
extern signed long hwtimer_schedule_timeout(unsigned long);
extern signed long hwtimer_usleep(unsigned long);


#endif /* _ASM_ARCH_HWTIMER_H */
