/*
 * include/asm-arm/arch-cxd4115/bam.h
 *
 * BAM definitions
 *
 * Copyright 2009 Sony Corporation
 *
 */
#ifndef __ARCH_CXD4115_REGS_BAM_H
#define __ARCH_CXD4115_REGS_BAM_H

#define BAM_LOAD_SET		0x014
# define BAM_MODE_NONE		 0x00
# define BAM_MODE_COUNT		 0x10
# define BAM_MODE_CHECK		 0x20
# define BAM_START		 0x04
# define BAM_CTRL_CPU		 0x00
# define BAM_CTRL_SYNC0		 0x01
# define BAM_CTRL_SYNC1		 0x02
# define BAM_CTRL_TIMER	 	 0x03
#define BAM_AXI_MON1_IP1	0x100
# define BAM_AXI_MON1_DMC0_ALL	 0x0fffffff
#define BAM_AXI_MON1_IP2	0x104
# define BAM_AXI_MON1_IP2_ALL	 0xffffffff
#define BAM_MON1_BURST4_COUNT	0x108
#define BAM_MON1_BURST8_COUNT	0x10c
#define BAM_MON1_BURST12_COUNT	0x110
#define BAM_MON1_BURST16_COUNT	0x114
#define BAM_MON1_BURST_COUNT	0x118
#define BAM_DDR_WDQ_IP1		0x124
#define BAM_DDR_RDQ_IP1		0x128

#define BAM_COUNT_MAX		0x000fffff

#ifdef CONFIG_ARCH_CXD4115
/* IP0..31 */
# define BAM_CPU_R0	21
//# define BAM_CPU_R0	17   /* CXD9938 */
#endif /* CONFIG_ARCH_CXD4115 */

#endif
