/*
 * include/asm-arm/arch-cxd4115/time.h
 *
 * OS timer definitions
 *
 * Copyright 2007,2008,2009 Sony Corporation
 *
 * This code is based on include/asm-arm/arch-integrator/time.h.
 */
/*
 *  linux/include/asm-arm/arch-integrator/time.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ASM_ARCH_TIME_H__
#define __ASM_ARCH_TIME_H__

#include <asm/system.h>
#include <asm/arch/timex.h>

#ifdef CONFIG_LOCAL_TIMER_TICK
# include <asm/hardware/arm_twd.h>
#else /* CONFIG_LOCAL_TIMER_TICK */
# include <asm/arch/regs-timer.h>
# define TIMER_FOR_TICK  (1)
# define TIMER_FOR_SCHED (2)
#endif /* !CONFIG_LOCAL_TIMER_TICK */


/*
 * How long is the timer interval?
 */

#define TIMER_RELOAD	(CLOCK_TICK_RATE/HZ)
#if CLOCK_TICK_RATE == 1000000
# define TICKS2USECS(x) (x)
#elif CLOCK_TICK_RATE == 2000000
# define TICKS2USECS(x) (((x) + 1) >> 1)
#else
# error "Unexpected CLOCK_TICK_RATE"
#endif

#define FREERUN_TICK_RATE SCHED_TICK_RATE

#ifndef __ASSEMBLY__
extern unsigned long long read_sched_clock(void);

# ifdef CONFIG_LOCAL_TIMER_TICK
static inline unsigned long read_freerun(void)
{
	/* 1's complement: because WDOG is down counter. */
	return ~readl(VA_LOCALTIMER + TWD_WDOG_COUNTER);
}
# else /* CONFIG_LOCAL_TIMER_TICK */
static inline unsigned long read_freerun(void)
{
	return readl(VA_TIMER(TIMER_FOR_SCHED)+CXD4105_TIMERREAD);
}
# endif /* CONFIG_LOCAL_TIMER_TICK */

extern unsigned long (*gettimeoffset)(void);
extern void cxd4115_timer_early_init(void);
#endif /* !__ASSEMBLY__ */
#endif /* __ASM_ARCH_TIME_H__ */
