/*
 * include/asm-arm/arch-cxd4115/timex.h
 *
 * Base clock definitions
 *
 * Copyright 2007,2008,2009 Sony Corporation
 *
 * This code is based on include/asm-arm/arch-integrator/timex.h.
 */
/*
 *  linux/include/asm-arm/arch-integrator/timex.h
 *
 *  Integrator architecture timex specifications
 *
 *  Copyright (C) 1999 ARM Limited
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ASM_ARCH_TIMEX_H__
#define __ASM_ARCH_TIMEX_H__

#ifndef MHZ
#define MHZ (1000000)
#endif

#define CXD4115_LOCALTIMER_CLK	(CONFIG_CXD4115_CPUCLK / 2)

#ifdef CONFIG_LOCAL_TIMER_TICK

# define CLOCK_TICK_RATE	(1 * MHZ)
# define CXD4115_LOCALTIMER_DIV	(CXD4115_LOCALTIMER_CLK / CLOCK_TICK_RATE)
# define SCHED_TICK_RATE	(2 * MHZ)
# define CXD4115_WDOG_DIV	(CXD4115_LOCALTIMER_CLK / SCHED_TICK_RATE)

#else /* CONFIG_LOCAL_TIMER_TICK */

# define CLOCK_TICK_RATE	(1 * MHZ)
# define CXD4115_TMCK_TICK_DIV	TMCK_DIV4
# define SCHED_TICK_RATE	(2 * MHZ)
# define CXD4115_TMCK_SCHED_DIV	TMCK_DIV2

#endif /* CONFIG_LOCAL_TIMER_TICK */

#endif /* __ASM_ARCH_TIMEX_H__ */
