/*
 * include/asm-arm/hardware/pmc.h
 *
 * MPCore Performance Monitor Register Access
 *
 * Copyright 2005,2006 Sony Corporation
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 */
#ifndef __ASM_HARDWARE_PMC_H__
#define __ASM_HARDWARE_PMC_H__

#define PMC_CCNT 1
#define PMC_PMN0 2
#define PMC_PMN1 3

#define __PMC_RESTART	0x07

#define rdpmc(id,val) \
	asm volatile ("mrc p15,0,%0,c15,c12," __stringify(id) \
		      :"=r"(val)::"cc");

#ifdef CONFIG_OPROFILE
static inline void pmc_restart(unsigned char ev1, unsigned char ev2)
{
}
#else
static inline void pmc_restart(unsigned char ev1, unsigned char ev2)
{
	register unsigned int pmnc;

	pmnc = (ev1 << 20) | (ev2 << 12) | __PMC_RESTART;
	asm volatile("mcr p15,0,%0,c15,c12,0" ::"r"(pmnc):"cc");
}
#endif /* CONFIG_OPROFILE */
#endif /* __ASM_HARDWARE_PMC_H__ */
