/*-----------------------------------------------------------------------------
 * drivers/usb/mcd/usb_mcd_device.c
 * 
 * USB controller driver
 * 
 * Copyright 2009 Sony Corporation
 *
 * This file is part of the Inventra Controller Driver for Linux.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *---------------------------------------------------------------------------*/

#ifndef _USB_MCD_HUB_H_
#define _USB_MCD_HUB_H_

/* Host RootHub Vendor Requests */
#define MCD_DEVREQ_H2D_V_O	0x43
#define McdClearPortFeature	((MCD_DEVREQ_H2D_V_O << 8) | \
				 USB_REQ_CLEAR_FEATURE)
#define McdSetPortFeature	((MCD_DEVREQ_H2D_V_O << 8) | \
				 USB_REQ_SET_FEATURE)

#define MCD_PORT_FEAT_EP_NO_DMA		1
#define MCD_PORT_FEAT_TEST_SE0		2
#define MCD_PORT_FEAT_TEST_J		3
#define MCD_PORT_FEAT_TEST_K		4
#define MCD_PORT_FEAT_TEST_PACKET	5
#define MCD_PORT_FEAT_TEST_SETUP	6
#define MCD_PORT_FEAT_TEST_IN		7

#endif			/* _USB_MCD_HUB_H_ */
